/*
 * wlanportal.c - WLAN-Weiterleitung fr tiny httpd
 * Copyright (C) 2007 Carsten Maul
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Copyright Carsten Maul

#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <sys/socket.h> 
#include <netinet/in.h> 
#include <net/if_arp.h> 
#include <errno.h> 
#include <sys/ioctl.h> 
#include <arpa/inet.h> 


#define INTERFACE "br0"
#define URL "http://wlanportal.meinefirma.de"


void html_errpage(char * title, char *mesg) {
   printf("%s%c%c\n","Content-Type:text/html;charset=iso-8859-1",13,10);  
   printf("<html>\n<head>\n<title>%s</title>\n</head>\n",title);
   printf("<body>\n");
   printf("%s",mesg);
   printf("</body></html>\n");
}

int main(void) {

    char * cgiraddr;

    FILE *fp;

    char host[100];
    char line[200];
    char mask[100];
    char dev[100];
    char ip[100];
    char hwa[100];
    char macaddr[100];
    char iptcmd[1024];
    int type, flags, num;

    host[0] = '\0';
 
    cgiraddr = getenv("REMOTE_ADDR");
       
    if(cgiraddr!=NULL) {
    
        // ARP-Tabelle in /proc oeffnen
        if ((fp = fopen("/proc/net/arp", "r")) == NULL) {
                perror("/proc/net/arp");
                return EXIT_FAILURE;
        }

        // Erste Zeile ignorieren
        if (fgets(line, sizeof(line), fp) != (char *) NULL) {
                strcpy(mask, "-");
                strcpy(dev, "-");

                // ARP-Eintraege Zeile fuer Zeile lesen
                for (; fgets(line, sizeof(line), fp);) {
                        num = sscanf(line, "%s 0x%x 0x%x %100s %100s %100s\n", ip, &type, &flags, hwa, mask, dev);
                        if (num < 4)
                                break;
                        if ((strcmp(cgiraddr,ip) == 0)) {
                          strcpy(macaddr,hwa);
                        }
                }
        }

		// iptables-Kommando im sudo-Kontext mit Parametern als String zusammensetzen
        sprintf(iptcmd,"iptables -t nat -I PREROUTING -p tcp --dport 80 -i %s -m mac --mac-source %s -j ACCEPT\n",INTERFACE,macaddr);

        // Befehl absetzen
        if (!system(iptcmd)) {
			// Bei erfolgreicher Ausfuehrung HTTP-Weiterleitung
			fprintf(stdout,"Status: 302 Moved\nLocation: %s\n\n",URL);
		} else {
			// Bei Problemen Fehlermeldung ausgeben
			printf("%s\n",iptcmd);
			html_errpage("Fehler","Fehler: Konnte die MAC-Adresse nicht registrieren\n");
			return EXIT_FAILURE;
        }
	} else {
		// Bei Problemen Fehlermeldung ausgeben
		html_errpage("Fehler","Fehler: Konnte die MAC-Adresse nicht ermitteln!\n");
		return EXIT_FAILURE;
	}

	return EXIT_SUCCESS;

}
